// Generated by Create API
// https://github.com/CreateAPI/CreateAPI
//
// swiftlint:disable all

import Foundation

public struct AppPreviewSetResponse: Codable {
	/// AppPreviewSet
	public var data: AppPreviewSet
	public var included: [IncludedItem]?
	public var links: DocumentLinks

	public enum IncludedItem: Codable {
		case appStoreVersionLocalization(AppStoreVersionLocalization)
		case appCustomProductPageLocalization(AppCustomProductPageLocalization)
		case appStoreVersionExperimentTreatmentLocalization(AppStoreVersionExperimentTreatmentLocalization)
		case appPreview(AppPreview)

		public init(from decoder: Decoder) throws {
			let container = try decoder.singleValueContainer()
			if let value = try? container.decode(AppStoreVersionLocalization.self) {
				self = .appStoreVersionLocalization(value)
			} else if let value = try? container.decode(AppCustomProductPageLocalization.self) {
				self = .appCustomProductPageLocalization(value)
			} else if let value = try? container.decode(AppStoreVersionExperimentTreatmentLocalization.self) {
				self = .appStoreVersionExperimentTreatmentLocalization(value)
			} else if let value = try? container.decode(AppPreview.self) {
				self = .appPreview(value)
			} else {
				throw DecodingError.dataCorruptedError(in: container, debugDescription: "Failed to intialize `oneOf`")
			}
		}

		public func encode(to encoder: Encoder) throws {
			var container = encoder.singleValueContainer()
			switch self {
			case .appStoreVersionLocalization(let value): try container.encode(value)
			case .appCustomProductPageLocalization(let value): try container.encode(value)
			case .appStoreVersionExperimentTreatmentLocalization(let value): try container.encode(value)
			case .appPreview(let value): try container.encode(value)
			}
		}
	}

	public init(data: AppPreviewSet, included: [IncludedItem]? = nil, links: DocumentLinks) {
		self.data = data
		self.included = included
		self.links = links
	}

	public init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: StringCodingKey.self)
		self.data = try values.decode(AppPreviewSet.self, forKey: "data")
		self.included = try values.decodeIfPresent([IncludedItem].self, forKey: "included")
		self.links = try values.decode(DocumentLinks.self, forKey: "links")
	}

	public func encode(to encoder: Encoder) throws {
		var values = encoder.container(keyedBy: StringCodingKey.self)
		try values.encode(data, forKey: "data")
		try values.encodeIfPresent(included, forKey: "included")
		try values.encode(links, forKey: "links")
	}
}
